VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MsgBx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'CLASS MODULE MESSAGE OR INPUT BOXES,
'MAIN MODULE:   MsgBx.

'There should be nothing here that is specific to any
'particular project except that,

'1 The error routines and the use of the CANCEL button
'  require a Public Boolean, 'canceled', in the main program.

' Philip Bolt, 2005

Option Explicit
Option Compare Text

Private Const n_ctrl As Integer = 13    'Number of controls.

'Default form data.
Private Const def_font As String = "Microsoft Sans Serif"  'Font name.
Private Const def_pt As Single = 10                 'Point size, (Text Box = 12, 1.2*10)
Private Const def_scale As Single = 1               'Scale factor.
Private Const def_bg_col As Long = &HE0E0E0         'Background colour.
Private Const def_bu_col As Long = &HC0C0C0         'Button colour.
Private Const but_wid As Integer = 1200             'Button width.
Private Const but_ht As Integer = 420               'Button and Text Box height.

Private scle As Single                  'Current scale value.

Private mes_ic_str() As String          'Icon file name array.
Private path_way As String              'Application path string.

Private setup As Boolean                'Data set-up flag.

Private frm As Object                   'The message_box form object.
Private ctrl() As Object                'Control array.

Private m As New mbx                    'Message Box object, (for error routine).

'Object constructor.
'Run when the object is created.

Private Sub Class_Initialize()

    If Not setup Then
        set_up
        setup = True
    End If
 
End Sub

'Procedure name:    Class_Terminate()
'Run when a page is terminated.

Private Sub Class_Terminate()
 
End Sub

'Routine to set up data for the mesage_box form.
'Procedure name:    set_up

Private Sub set_up()

    Dim j As Integer, fn As String
 
    path_way = App.Path + "\"   'Define the application path string.
    
    Set frm = mesage_box

    ReDim ctrl(n_ctrl)              'Dimension the control array.
    Set ctrl(0) = frm.Command1      'Message box OK button.
    Set ctrl(1) = frm.Command2      'Message box CANCEL button.
    Set ctrl(2) = frm.Command4      'Message box YES button.
    Set ctrl(3) = frm.Command3      'Message box NO button.
    Set ctrl(4) = frm.Command5      'Message box ABORT button.
    Set ctrl(5) = frm.Command6      'Message box RETRY button.
    Set ctrl(6) = frm.Command7      'Message box IGNORE button.
    Set ctrl(7) = frm.Label1        'Message box text area.
    Set ctrl(8) = frm.Text1         'Message box Text box, (Input_box).
    Set ctrl(9) = frm.mes_icon      'Message box form icon picture box.
    Set ctrl(10) = frm.Image1(0)    'Message box Icon Image Boxes.
    Set ctrl(11) = frm.Image1(1)
    Set ctrl(12) = frm.Image1(2)
    Set ctrl(13) = frm.Image1(3)
    
    ReDim but_pos(2)                'Message box button positions.
    but_pos(0) = 300
    but_pos(1) = 1750
    but_pos(2) = 3200
    
    ReDim mes_ic_str(4)             'Message box icons.
    mes_ic_str(1) = "ms_crit.gif"
    mes_ic_str(2) = "ms_ques.gif"
    mes_ic_str(3) = "ms_exclam.gif"
    mes_ic_str(4) = "ms_info.gif"
    
    scle = 1                        'Set the default scale factor and
    mesage_box.scale_factor (scle)  'Store it on the Form.
    
    On Error GoTo etrap             'Set error trap.

    fn = "redhall.ico"                                  'Define the error file name and
    frm.icon = LoadPicture(path_way + "\redhall.ico")   'load the Form icon.
    
    For j = 10 To 13
        fn = mes_ic_str(j - 9)                                      'Define the error file name and
        ctrl(j).Picture = LoadPicture(path_way + mes_ic_str(j - 9)) 'load the Box icons.
    Next

    On Error GoTo 0     'Clear the 'On error' jump.
    
    Exit Sub
    
etrap: 'ERROR TRAP
    error_report Err.Number, fn, "'set_up'"
    
End Sub

'Routine to modify the FONT, SIZE or COLOUR of the box.
'Procedure name:    modify(Optional fnt As String = "", Optional sz As integer = 0,
'                          Optional sc As Single = 1, Optional bg_clr As Long = 0,
'                          Optional bu_clr As Long = 0)

'Parameters:        fnt;    the font name,
'                   sz;     the font point size,
'                   sc;     the scale factor,
'                   bg_clr; the background colour,
'                   bu_clr; the button colour.

Public Sub modify(Optional fnt As String = "", Optional sz As Integer = 0, _
                  Optional sc As Single = 1, Optional bg_clr As Long = 0, _
                  Optional bu_clr As Long = 0)

    If fnt <> "" Then
        change_font fnt     'Change the fonts.
    End If
    
    If sz > 5 Then
        change_f_s sz       'Change the font sizes, (don't allow less than 6pt.)
    End If
    
    If sc <> 1 And sc > 0 Then
        scale_box sc        'Scale the controls.
    End If
    
    If bg_clr > 0 Then
        change_bg bg_clr    'Change the backgound colour.
    End If
    
    If bu_clr > 0 Then
        change_bu bu_clr    'Change the button colour.
    End If

End Sub

'Routine to resetthe FONT, SIZE or COLOUR of the box to the defaults.
'The parameters are flags; 0 = leave, 1 = change to default.
'Procedure name:    defaults(Optional fn As integer = 1, Optional sz As integer = 1,
'                            Optional sc As Single = 1, Optional bg As integer = 1,
'                            Optional bu As integer = 1)

'Parameters:        fn; the font name flag,
'                   sz; the font point size,
'                   sc; the scale factor,
'                   bg; the background colour flag,
'                   bu; the button colour flag.

Public Sub defaults(Optional fn As Integer = 1, Optional sz As Integer = 1, _
                    Optional sc As Single = 1, Optional bg As Integer = 1, _
                    Optional bu As Integer = 1)

    If fn = 1 Then
        change_font def_font    'Change the fonts to the default.
    End If
    
    If sz = 1 Then
        change_f_s def_pt       'Change the font sizes to the defaults.
    End If
    
    If sc = 1 Then
        scale_box 1             'Scale the controls to the original.
    End If
    
    If bg = 1 Then
        change_bg def_bg_col    'Change the backgound colour to the default.
    End If
    
    If bu = 1 Then
        change_bu def_bu_col    'Change the button colour to the default.
    End If

End Sub

'Routine to change the font NAME of the various controls.
'Procedure name:    change_font(f_n)
'Parameter:         f_n;    the font name.

Private Sub change_font(f_n)

    Dim j As Integer
    
    ctrl(9).Font.Name = f_n         'Set the font name to check its validity.
    If ctrl(9).Font.Name = f_n Then 'the named font exists , so
        frm.FontName = f_n          'change the form's font and
        For j = 0 To 8
            ctrl(j).FontName = f_n  'that of the controls.
        Next
    Else
        m.message_box "Font, '" + f_n + "', isn't installed.", vbOKOnly, vbCritical, "Font ERROR"
    End If
    
End Sub

'Routine to change the font SIZE of the various controls.
'Procedure name:    change_f_s(pt)
'Parameter:         pt; the point size.

Private Sub change_f_s(pt)

    Dim j As Integer
    
    frm.FontSize = pt              'Set the form's font size and
    
    For j = 0 To 7
        ctrl(j).FontSize = pt      'that of the controls.
    Next
    
    ctrl(8).FontSize = pt * 1.2    'Set the Text Box font to 1.2 x the standard size.
    
End Sub

'Routine to change the SIZE of the various controls.
'Procedure name:    scale_box(scc)
'Parameter:         scc;    the scale factor.

Private Sub scale_box(scc)

    Dim j As Integer

    For j = 0 To 6
        With ctrl(j)
            .Width = but_wid * scc  'Re-size the button widths and
            .Height = but_ht * scc  'height.
        End With
    Next
    
    ctrl(8).Height = but_ht * scc   'Re-size the Text box height.
    
    change_f_s def_pt * scc         'Re-size the font point.
    
    mesage_box.scale_factor (scc)   'Store the scale factor on the Form.
    
End Sub

'Routine to change the BACKGROUND COLOUR of the various controls.
'Procedure name:    change_bg(cl)
'Parameter:         cl; the colour.

Private Sub change_bg(cl)

    Dim j As Integer
    
    frm.BackColor = cl      'Change the form's background and
    
    ctrl(7).BackColor = cl  'that of the Label and
    ctrl(9).BackColor = cl  'Picture box.

End Sub

'Routine to change the BACKGROUND COLOUR of the buttons.
'Procedure name:    change_bu(cl)
'Parameter:         cl; the colour.

Private Sub change_bu(cl)

    Dim j As Integer

    For j = 0 To 6
        ctrl(j).BackColor = cl  'Change the Buttons' colour.
    Next
    
End Sub

'Error routine to report the various errors.
'Procedure name:    error_report(e_num, f_nm, r_nme)
'Parameter:         e_num;  the error number,
'                   f_nm;  the file name, (where applicable),
'                   r_nme; the routine name.

Private Sub error_report(e_num, f_nm, r_nme)

    Dim txt As String
    
    Select Case e_num
        Case 53
            txt = "File '" + f_nm + "' doesn't exist."
        Case Else
            txt = "Error # " & Str(Err.Number) & " was generated by " _
            & vbCrLf & Err.Source & vbCrLf & Err.Description
    End Select
    
    m.message_box txt, vbOKOnly, vbCritical, r_nme + " ERROR"
    'MsgBox txt, vbOKOnly, r_nme + " ERROR"
        
    Err.Clear       'Clear the error object.

    canceled = True 'Set the CANCELed flag.
    
End Sub

